# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`reprepro`](#reprepro): Configures reprepro on a server

### Defined types

* [`reprepro::distribution`](#reprepro--distribution): Adds a "Distribution" to manage.
* [`reprepro::filterlist`](#reprepro--filterlist): Adds a FilterList  Packages list have the same syntax as the output of dpkg --get-selections
* [`reprepro::key`](#reprepro--key): Import a PGP key into the local keyring of the reprepro user
* [`reprepro::pull`](#reprepro--pull): Add a repository pull rule.
* [`reprepro::repository`](#reprepro--repository): Adds a packages repository.
* [`reprepro::update`](#reprepro--update): Adds a packages repository.

## Classes

### <a name="reprepro"></a>`reprepro`

Configures reprepro on a server

#### Parameters

The following parameters are available in the `reprepro` class:

* [`basedir`](#-reprepro--basedir)
* [`homedir`](#-reprepro--homedir)
* [`manage_user`](#-reprepro--manage_user)
* [`user_name`](#-reprepro--user_name)
* [`group_name`](#-reprepro--group_name)
* [`keys`](#-reprepro--keys)
* [`key_defaults`](#-reprepro--key_defaults)
* [`repositories`](#-reprepro--repositories)
* [`repositories_defaults`](#-reprepro--repositories_defaults)
* [`package_ensure`](#-reprepro--package_ensure)
* [`package_name`](#-reprepro--package_name)
* [`distributions_defaults`](#-reprepro--distributions_defaults)
* [`always_recurse`](#-reprepro--always_recurse)

##### <a name="-reprepro--basedir"></a>`basedir`

Data type: `String`

The base directory to house the repository.

Default value: `'/var/packages'`

##### <a name="-reprepro--homedir"></a>`homedir`

Data type: `String`

The home directory of the reprepro user.

Default value: `'/var/packages'`

##### <a name="-reprepro--manage_user"></a>`manage_user`

Data type: `Boolean`

if true, creates the user $user_name

Default value: `true`

##### <a name="-reprepro--user_name"></a>`user_name`

Data type: `String`

user_name who own reprepro

Default value: `'reprepro'`

##### <a name="-reprepro--group_name"></a>`group_name`

Data type: `String`

group of user who own reprepro

Default value: `'reprepro'`

##### <a name="-reprepro--keys"></a>`keys`

Data type: `Hash`

hash to create reprepro::key resources.

Default value: `{}`

##### <a name="-reprepro--key_defaults"></a>`key_defaults`

Data type: `Hash`

hash with defaults for keys creation.

Default value: `{}`

##### <a name="-reprepro--repositories"></a>`repositories`

Data type: `Hash`

hash to create reprepro::repository resources.

Default value: `{}`

##### <a name="-reprepro--repositories_defaults"></a>`repositories_defaults`

Data type: `Hash`

hash with defaults for reporitories creation.

Default value: `{}`

##### <a name="-reprepro--package_ensure"></a>`package_ensure`

Data type: `String`

what to ensure for packages

Default value: `'present'`

##### <a name="-reprepro--package_name"></a>`package_name`

Data type: `String`

name of the package to install

Default value: `'reprepro'`

##### <a name="-reprepro--distributions_defaults"></a>`distributions_defaults`

Data type: `Hash`

defaults to use for all distributions.
they may got overwritten from the repositories
distribution_defaults

Default value: `{}`

##### <a name="-reprepro--always_recurse"></a>`always_recurse`

Data type: `Boolean`

default value for always_recurse in the
define reprepro::repository
since recursing folders can be time consuming
you can avoid in normal runs and only recurse
for ensure => 'absent' repositories.
Default is to recurse always

Default value: `true`

## Defined types

### <a name="reprepro--distribution"></a>`reprepro::distribution`

Adds a "Distribution" to manage.

#### Examples

##### 

```puppet
reprepro::distribution {"lenny":
  repository    => "my-repository",
  origin        => "Camptocamp",
  label         => "Camptocamp",
  suite         => "stable",
  architectures => "i386 amd64 source",
  components    => "main contrib non-free",
  description   => "A simple example of repository distribution",
  sign_with     => "packages@camptocamp.com",
}
```

#### Parameters

The following parameters are available in the `reprepro::distribution` defined type:

* [`repository`](#-reprepro--distribution--repository)
* [`version`](#-reprepro--distribution--version)
* [`origin`](#-reprepro--distribution--origin)
* [`label`](#-reprepro--distribution--label)
* [`suite`](#-reprepro--distribution--suite)
* [`architectures`](#-reprepro--distribution--architectures)
* [`components`](#-reprepro--distribution--components)
* [`description`](#-reprepro--distribution--description)
* [`sign_with`](#-reprepro--distribution--sign_with)
* [`codename`](#-reprepro--distribution--codename)
* [`fakecomponentprefix`](#-reprepro--distribution--fakecomponentprefix)
* [`udebcomponents`](#-reprepro--distribution--udebcomponents)
* [`deb_indices`](#-reprepro--distribution--deb_indices)
* [`dsc_indices`](#-reprepro--distribution--dsc_indices)
* [`update`](#-reprepro--distribution--update)
* [`pull`](#-reprepro--distribution--pull)
* [`uploaders`](#-reprepro--distribution--uploaders)
* [`snapshots`](#-reprepro--distribution--snapshots)
* [`install_cron`](#-reprepro--distribution--install_cron)
* [`not_automatic`](#-reprepro--distribution--not_automatic)
* [`but_automatic_upgrades`](#-reprepro--distribution--but_automatic_upgrades)
* [`log`](#-reprepro--distribution--log)
* [`create_pull`](#-reprepro--distribution--create_pull)
* [`create_update`](#-reprepro--distribution--create_update)
* [`create_filterlist`](#-reprepro--distribution--create_filterlist)

##### <a name="-reprepro--distribution--repository"></a>`repository`

Data type: `String`

the name of the repository to attach this
distribution to.

##### <a name="-reprepro--distribution--version"></a>`version`

Data type: `Optional[String]`

distribution version

Default value: `undef`

##### <a name="-reprepro--distribution--origin"></a>`origin`

Data type: `Optional[String]`

package origin

Default value: `undef`

##### <a name="-reprepro--distribution--label"></a>`label`

Data type: `Optional[String]`

package label

Default value: `undef`

##### <a name="-reprepro--distribution--suite"></a>`suite`

Data type: `Optional[String]`

package suite

Default value: `undef`

##### <a name="-reprepro--distribution--architectures"></a>`architectures`

Data type: `String`

available architectures

##### <a name="-reprepro--distribution--components"></a>`components`

Data type: `String`

available components

##### <a name="-reprepro--distribution--description"></a>`description`

Data type: `Optional[String]`

a short description

Default value: `undef`

##### <a name="-reprepro--distribution--sign_with"></a>`sign_with`

Data type: `String`

email of the gpg key

Default value: `''`

##### <a name="-reprepro--distribution--codename"></a>`codename`

Data type: `String`

codename (defaults to $title)

Default value: `$title`

##### <a name="-reprepro--distribution--fakecomponentprefix"></a>`fakecomponentprefix`

Data type: `Optional[String]`

fakecomponentprefix

Default value: `undef`

##### <a name="-reprepro--distribution--udebcomponents"></a>`udebcomponents`

Data type: `String`

udebcomponents

Default value: `$components`

##### <a name="-reprepro--distribution--deb_indices"></a>`deb_indices`

Data type: `String`

file name and compression

Default value: `'Packages Release .gz .bz2'`

##### <a name="-reprepro--distribution--dsc_indices"></a>`dsc_indices`

Data type: `String`

file name and compression

Default value: `'Sources Release .gz .bz2'`

##### <a name="-reprepro--distribution--update"></a>`update`

Data type: `String`

update policy name

Default value: `''`

##### <a name="-reprepro--distribution--pull"></a>`pull`

Data type: `String`

pull policy name

Default value: `''`

##### <a name="-reprepro--distribution--uploaders"></a>`uploaders`

Data type: `String`

who is allowed to upload packages

Default value: `''`

##### <a name="-reprepro--distribution--snapshots"></a>`snapshots`

Data type: `Boolean`

create a reprepro snapshot on each update

Default value: `false`

##### <a name="-reprepro--distribution--install_cron"></a>`install_cron`

Data type: `Boolean`

install cron job to automatically include new packages

Default value: `true`

##### <a name="-reprepro--distribution--not_automatic"></a>`not_automatic`

Data type: `String`

automatic pined to 1 by using NotAutomatic,
value are "yes" or "no"

Default value: `''`

##### <a name="-reprepro--distribution--but_automatic_upgrades"></a>`but_automatic_upgrades`

Data type: `String`

set ButAutomaticUpgrades,
value are "yes" or "no"

Default value: `'no'`

##### <a name="-reprepro--distribution--log"></a>`log`

Data type: `String`

log

Default value: `''`

##### <a name="-reprepro--distribution--create_pull"></a>`create_pull`

Data type: `Hash`

hash to create reprepro::pull resource
the name will be appended to $pull

Default value: `{}`

##### <a name="-reprepro--distribution--create_update"></a>`create_update`

Data type: `Hash`

hash to create reprepro::update resource
the name will be appended to $update

Default value: `{}`

##### <a name="-reprepro--distribution--create_filterlist"></a>`create_filterlist`

Data type: `Hash`

hash to create reprerpo::filterlist resource

Default value: `{}`

### <a name="reprepro--filterlist"></a>`reprepro::filterlist`

Adds a FilterList

Packages list have the same syntax as the output of dpkg --get-selections

#### Examples

##### 

```puppet
reprepro::filterlist {"lenny-backports":
  ensure     => present,
  repository => "dev",
  packages   => [
    "git install",
    "git-email install",
    "gitk install",
  ],
}
```

#### Parameters

The following parameters are available in the `reprepro::filterlist` defined type:

* [`list_name`](#-reprepro--filterlist--list_name)
* [`ensure`](#-reprepro--filterlist--ensure)
* [`repository`](#-reprepro--filterlist--repository)
* [`packages`](#-reprepro--filterlist--packages)

##### <a name="-reprepro--filterlist--list_name"></a>`list_name`

Data type: `String`

name of the filter list

Default value: `$title`

##### <a name="-reprepro--filterlist--ensure"></a>`ensure`

Data type: `String`

present/absent, defaults to present

Default value: `'present'`

##### <a name="-reprepro--filterlist--repository"></a>`repository`

Data type: `String`

the name of the repository

##### <a name="-reprepro--filterlist--packages"></a>`packages`

Data type: `Array`

a list of packages, if the list is empty, the file
content won't be managed by puppet

Default value: `[]`

### <a name="reprepro--key"></a>`reprepro::key`

Import a PGP key into the local keyring of the reprepro user

#### Parameters

The following parameters are available in the `reprepro::key` defined type:

* [`key_name`](#-reprepro--key--key_name)
* [`key_source`](#-reprepro--key--key_source)
* [`key_content`](#-reprepro--key--key_content)

##### <a name="-reprepro--key--key_name"></a>`key_name`

Data type: `String`

name of the key

Default value: `$title`

##### <a name="-reprepro--key--key_source"></a>`key_source`

Data type: `Optional[String]`

Path to the key in gpg --export format. This is
used as the source parameter in a puppet File resource.

Default value: `undef`

##### <a name="-reprepro--key--key_content"></a>`key_content`

Data type: `Optional[String]`

define the key content instead of pointing to a source file

Default value: `undef`

### <a name="reprepro--pull"></a>`reprepro::pull`

Add a repository pull rule.

#### Examples

##### 

```puppet
reprepro::pull {'lenny-backports':
  repository  => 'localpkgs',
  from        => 'dev',
  filter_name => 'lenny-backports',
}
```

#### Parameters

The following parameters are available in the `reprepro::pull` defined type:

* [`name`](#-reprepro--pull--name)
* [`repository`](#-reprepro--pull--repository)
* [`from`](#-reprepro--pull--from)
* [`components`](#-reprepro--pull--components)
* [`architectures`](#-reprepro--pull--architectures)
* [`udebcomponents`](#-reprepro--pull--udebcomponents)
* [`filter_action`](#-reprepro--pull--filter_action)
* [`filter_name`](#-reprepro--pull--filter_name)
* [`filter_src_name`](#-reprepro--pull--filter_src_name)
* [`filter_formula`](#-reprepro--pull--filter_formula)

##### <a name="-reprepro--pull--name"></a>`name`

the name of the pull rule to use in the Pull
field in conf/distributions

##### <a name="-reprepro--pull--repository"></a>`repository`

Data type: `String`

the local repository to pull to

##### <a name="-reprepro--pull--from"></a>`from`

Data type: `String`

The codename of the distribution to pull packages from.

##### <a name="-reprepro--pull--components"></a>`components`

Data type: `String`

The components of the distribution to get from.

Default value: `''`

##### <a name="-reprepro--pull--architectures"></a>`architectures`

Data type: `String`

The architectures to update.

Default value: `''`

##### <a name="-reprepro--pull--udebcomponents"></a>`udebcomponents`

Data type: `String`

Like Components but for the udebs.

Default value: `''`

##### <a name="-reprepro--pull--filter_action"></a>`filter_action`

Data type: `String`

default action when something is not found in the list

Default value: `''`

##### <a name="-reprepro--pull--filter_name"></a>`filter_name`

Data type: `String`

a list of filenames in the format of dpkg --get-selections

Default value: `''`

##### <a name="-reprepro--pull--filter_src_name"></a>`filter_src_name`

Data type: `String`

FilterSrcList parameter

Default value: `''`

##### <a name="-reprepro--pull--filter_formula"></a>`filter_formula`

Data type: `String`

FilterFormula

Default value: `''`

### <a name="reprepro--repository"></a>`reprepro::repository`

Adds a packages repository.

#### Examples

##### 

```puppet
reprepro::repository { 'localpkgs':
  ensure  => present,
  options => ['verbose', 'basedir .'],
}
```

#### Parameters

The following parameters are available in the `reprepro::repository` defined type:

* [`repo_name`](#-reprepro--repository--repo_name)
* [`ensure`](#-reprepro--repository--ensure)
* [`incoming_name`](#-reprepro--repository--incoming_name)
* [`incoming_dir`](#-reprepro--repository--incoming_dir)
* [`incoming_tmpdir`](#-reprepro--repository--incoming_tmpdir)
* [`incoming_allow`](#-reprepro--repository--incoming_allow)
* [`options`](#-reprepro--repository--options)
* [`createsymlinks`](#-reprepro--repository--createsymlinks)
* [`documentroot`](#-reprepro--repository--documentroot)
* [`max_files`](#-reprepro--repository--max_files)
* [`always_recurse`](#-reprepro--repository--always_recurse)
* [`distributions`](#-reprepro--repository--distributions)
* [`distributions_defaults`](#-reprepro--repository--distributions_defaults)

##### <a name="-reprepro--repository--repo_name"></a>`repo_name`

Data type: `String`

the name of the repository

Default value: `$title`

##### <a name="-reprepro--repository--ensure"></a>`ensure`

Data type: `String`

present/absent, defaults to present

Default value: `'present'`

##### <a name="-reprepro--repository--incoming_name"></a>`incoming_name`

Data type: `String`

the name of the rule-set, used as argument

Default value: `'incoming'`

##### <a name="-reprepro--repository--incoming_dir"></a>`incoming_dir`

Data type: `String`

the name of the directory to scan for .changes files

Default value: `'incoming'`

##### <a name="-reprepro--repository--incoming_tmpdir"></a>`incoming_tmpdir`

Data type: `String`

directory where the files are copied into
before they are read

Default value: `'tmp'`

##### <a name="-reprepro--repository--incoming_allow"></a>`incoming_allow`

Data type: `Optional[Variant[String, Array]]`

allowed distributions

Default value: `undef`

##### <a name="-reprepro--repository--options"></a>`options`

Data type: `Array`

reprepro options

Default value: `['verbose', 'ask-passphrase', 'basedir .']`

##### <a name="-reprepro--repository--createsymlinks"></a>`createsymlinks`

Data type: `Boolean`

create suite symlinks

Default value: `false`

##### <a name="-reprepro--repository--documentroot"></a>`documentroot`

Data type: `Optional[String]`

documentroot of the webserver (default undef)
if set, softlinks to the reprepro directories are made
the directory $documentroot must already exist

Default value: `undef`

##### <a name="-reprepro--repository--max_files"></a>`max_files`

Data type: `Optional[Integer]`

maximum number of file resources created for recursion
see puppet file resource, available only on puppet > 7

Default value: `undef`

##### <a name="-reprepro--repository--always_recurse"></a>`always_recurse`

Data type: `Optional[Boolean]`

since recursing folders can be time consuming
you can avoid in normal runs and only recurse
for ensure => 'absent' repositories.
Default is taken from reprepro::always_recurse

Default value: `undef`

##### <a name="-reprepro--repository--distributions"></a>`distributions`

Data type: `Hash`

hash to define distributions in this repository

Default value: `{}`

##### <a name="-reprepro--repository--distributions_defaults"></a>`distributions_defaults`

Data type: `Hash`

defaults for all distributions in this repository

Default value: `{}`

### <a name="reprepro--update"></a>`reprepro::update`

Adds a packages repository.

#### Examples

##### 

```puppet
reprepro::update {"lenny-backports":
  suite       => 'lenny',
  repository  => "dev",
  url         => 'http://backports.debian.org/debian-backports',
  filter_name => "lenny-backports",
}
```

#### Parameters

The following parameters are available in the `reprepro::update` defined type:

* [`update_name`](#-reprepro--update--update_name)
* [`suite`](#-reprepro--update--suite)
* [`repository`](#-reprepro--update--repository)
* [`url`](#-reprepro--update--url)
* [`architectures`](#-reprepro--update--architectures)
* [`components`](#-reprepro--update--components)
* [`udebcomponents`](#-reprepro--update--udebcomponents)
* [`flat`](#-reprepro--update--flat)
* [`verify_release`](#-reprepro--update--verify_release)
* [`ignore_release`](#-reprepro--update--ignore_release)
* [`filter_action`](#-reprepro--update--filter_action)
* [`filter_name`](#-reprepro--update--filter_name)
* [`filter_src_name`](#-reprepro--update--filter_src_name)
* [`download_lists_as`](#-reprepro--update--download_lists_as)
* [`getinrelease`](#-reprepro--update--getinrelease)

##### <a name="-reprepro--update--update_name"></a>`update_name`

Data type: `String`

the name of the update-upstream use in the
Update field in conf/distributions

Default value: `$title`

##### <a name="-reprepro--update--suite"></a>`suite`

Data type: `String`

package suite

##### <a name="-reprepro--update--repository"></a>`repository`

Data type: `String`

the name of the repository

##### <a name="-reprepro--update--url"></a>`url`

Data type: `String`

a valid repository URL

##### <a name="-reprepro--update--architectures"></a>`architectures`

Data type: `Optional[String]`

architectures

Default value: `undef`

##### <a name="-reprepro--update--components"></a>`components`

Data type: `Optional[String]`

components

Default value: `undef`

##### <a name="-reprepro--update--udebcomponents"></a>`udebcomponents`

Data type: `Optional[String]`

udebcomponents

Default value: `undef`

##### <a name="-reprepro--update--flat"></a>`flat`

Data type: `Optional[String]`

flat

Default value: `undef`

##### <a name="-reprepro--update--verify_release"></a>`verify_release`

Data type: `String`

check the GPG signature Releasefile

Default value: `'blindtrust'`

##### <a name="-reprepro--update--ignore_release"></a>`ignore_release`

Data type: `String`

ignore_release

Default value: `'No'`

##### <a name="-reprepro--update--filter_action"></a>`filter_action`

Data type: `String`

default action when something is not found in the list

Default value: `''`

##### <a name="-reprepro--update--filter_name"></a>`filter_name`

Data type: `String`

Name of a filter list created with reprepro::filterlist,
matching binary packages

Default value: `''`

##### <a name="-reprepro--update--filter_src_name"></a>`filter_src_name`

Data type: `String`

Name of a filter list created with reprepro::filterlist,
matching source packages

Default value: `''`

##### <a name="-reprepro--update--download_lists_as"></a>`download_lists_as`

Data type: `String`

specify in which order reprepro will look for a usable
variant of needed index files ( .gz, .bz2, .lzma, .xz and .diff)

Default value: `''`

##### <a name="-reprepro--update--getinrelease"></a>`getinrelease`

Data type: `Optional[String]`

if this is set to 'no', no InRelease file is downloaded but
only Release (and Release.gpg ) are tried.

Default value: `undef`

